unit Unit1;

(***************************************************************************
*                                                                          *
*     TComSW    - Sample Application                                       *
*     ver:1.0                                                              *
*                                                                          *
*     Username/Serial check, generate                                      *
*                                                                          *
*     06/20/2000   written by Snuki - snuki@freemail.hu                    *
***************************************************************************)
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, ExtCtrls, uSchSW;

type
  TfrmMain = class(TForm)
    eName: TEdit;
    eSerial: TEdit;
    eHidPrefix: TEdit;
    Label1: TLabel;
    lSerial: TLabel;
    Label3: TLabel;
    rgMethod: TRadioGroup;
    Memo1: TMemo;
    lSW: TLabel;
    eHidSuffix: TEdit;
    ePrefix: TEdit;
    eSuffix: TEdit;
    eRegfilename: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    RegFileName: TLabel;
    btGenSerial: TButton;
    sbLoad: TSpeedButton;
    sbSave: TSpeedButton;
    SchSW1: TSchSW;
    BitBtn1: TBitBtn;
    Label2: TLabel;
    Label4: TLabel;
    lCorrect: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure SchSW1ChangeSW(Sender: TObject);
    procedure eNameChange(Sender: TObject);
    procedure eSerialChange(Sender: TObject);
    procedure eHidPrefixChange(Sender: TObject);
    procedure eHidSuffixChange(Sender: TObject);
    procedure ePrefixChange(Sender: TObject);
    procedure eSuffixChange(Sender: TObject);
    procedure eRegfilenameChange(Sender: TObject);
    procedure btGenSerialClick(Sender: TObject);
    procedure sbLoadClick(Sender: TObject);
    procedure sbSaveClick(Sender: TObject);
    procedure rgMethodClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;
  MainPath : String;

implementation

{$R *.DFM}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  MainPath:=ExtractFilePath(Application.ExeName);
  SchSW1.RegFileName:=MainPath+eRegfilename.Text;
  eName.Text:=SchSW1.UserName;
  eSerial.Text:=SchSW1.UserSerial;
  lCorrect.Caption:=SchSW1.GenerateSerial(eName.text);
end;

procedure TfrmMain.BitBtn1Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TfrmMain.SchSW1ChangeSW(Sender: TObject);
begin
  if SchSW1.SW then
  begin
    lSW.Font.Color:=clRed;
    lSW.Caption:='Shareware';
  end
  else begin;
    lSW.Font.Color:=clGreen;
    lSW.Caption:='OK';
  end
end;

procedure TfrmMain.eNameChange(Sender: TObject);
begin
  SchSW1.UserName:=eName.Text;
  lCorrect.Caption:=SchSW1.GenerateSerial(eName.text);
end;

procedure TfrmMain.eSerialChange(Sender: TObject);
begin
  SchSW1.UserSerial:=eSerial.Text;
  lCorrect.Caption:=SchSW1.GenerateSerial(eName.text);
end;

procedure TfrmMain.eHidPrefixChange(Sender: TObject);
begin
  SchSW1.HiddenPrefix:=eHidPrefix.Text;
  lCorrect.Caption:=SchSW1.GenerateSerial(eName.text);
end;

procedure TfrmMain.eHidSuffixChange(Sender: TObject);
begin
  SchSW1.HiddenSuffix:=eHidSuffix.Text;
  lCorrect.Caption:=SchSW1.GenerateSerial(eName.text);
end;

procedure TfrmMain.ePrefixChange(Sender: TObject);
begin
  SchSW1.Prefix:=ePrefix.Text;
  lCorrect.Caption:=SchSW1.GenerateSerial(eName.text);
end;

procedure TfrmMain.eSuffixChange(Sender: TObject);
begin
  SchSW1.Suffix:=eSuffix.Text;
  lCorrect.Caption:=SchSW1.GenerateSerial(eName.text);
end;

procedure TfrmMain.eRegfilenameChange(Sender: TObject);
begin
  SchSW1.RegFileName:=MainPath+eRegfilename.Text;
  sbLoad.Enabled:=(eRegfilename.Text<>'');
  sbSave.Enabled:=(eRegfilename.Text<>'');
end;

procedure TfrmMain.btGenSerialClick(Sender: TObject);
begin
  eSerial.Text:=SchSW1.GenerateSerial(eName.text);
end;

procedure TfrmMain.sbLoadClick(Sender: TObject);
begin
  case SchSW1.LoadReg of
    ecOK         : Memo1.Lines.Add(IntToStr(Memo1.Lines.Count+1)+'. Load: ecOK        - All OK');
    ecNonExists  : Memo1.Lines.Add(IntToStr(Memo1.Lines.Count+1)+'. Load: ecNonExists - File not exist');
    ecIO         : Memo1.Lines.Add(IntToStr(Memo1.Lines.Count+1)+'. Load: ecIO        - Other I/O problem');
  end;
  eName.Text:=SchSW1.UserName;
  eSerial.Text:=SchSW1.UserSerial;
end;

procedure TfrmMain.sbSaveClick(Sender: TObject);
begin
  if eRegfilename.text='' then exit;
  case SchSW1.SaveReg of
    ecOK         : Memo1.Lines.Add(IntToStr(Memo1.Lines.Count+1)+'. Save: ecOK        - All OK');
    ecNonExists  : Memo1.Lines.Add(IntToStr(Memo1.Lines.Count+1)+'. Save: ecNonExists - File not exist');
    ecIO         : Memo1.Lines.Add(IntToStr(Memo1.Lines.Count+1)+'. Save: ecIO        - Other I/O problem');
  end;
end;

procedure TfrmMain.rgMethodClick(Sender: TObject);
begin
  case rgMethod.ItemIndex of
    0: SchSW1.Method:=smNormal;
    1: SchSW1.Method:=smBack;
    2: SchSW1.Method:=smPair;
    3: SchSW1.Method:=smPreSuff;
  end;
  eHidPrefix.Enabled:=(rgMethod.ItemIndex<>0);
  eHidSuffix.Enabled:=(rgMethod.ItemIndex<>0);
  ePrefix.Enabled:=(rgMethod.ItemIndex<>0);
  eSuffix.Enabled:=(rgMethod.ItemIndex<>0);
  lCorrect.Caption:=SchSW1.GenerateSerial(eName.text);
end;

end.
